#!/usr/bin/env perl

use warnings;
use strict;

my (@manuf, @product, @name);
my ($manuf, $product, $name);
my (@indmanuf, @indproduct, @indname);
my ($indmanuf, $indproduct, $indname);
my (@inds);
my ($s);
my ($s1);

if ($#ARGV < 1)
{
	print "usage: $0 add_readers.txt Info.plist\n";
	exit;
}

open IN, "< $ARGV[0]" or die "Can't open $ARGV[0]: $!";
while (<IN>)
{
	next if (m/^#/);
	next if (m/^$/);

	chomp;
	($manuf, $product, $name) = split /:/;
	# print "m: $manuf, p: $product, n: $name\n";
	push @manuf, $manuf;
	push @product, $product;
	push @name, $name
}
close IN;

map { $_ = "\t\t<string>$_</string>\n" } @manuf;
map { $_ = "\t\t<string>$_</string>\n" } @product;
map { $_ = "\t\t<string>$_</string>\n" } @name;

$s = 0;

open IN, "< $ARGV[1]" or die "Can't open $ARGV[1]: $!";

while (<IN>)
{
	$s1 = $_;
	if (m/ifdVendorID/)
	{
		$indmanuf = 0;
		$s = 1;
	}
	if (m/ifdProductID/)
	{
		$indproduct = 0;
		$s = 2;
	}
	if (m/ifdFriendlyName/)
	{
		$indname = 0;
		$s = 3;
	}
	if ($s == 1)
	{
		$indmanuf = $indmanuf + 1;
		foreach(@manuf)
		{
			if(index($s1, $_) > -1)
			{
				$s = 0;
			}
		}
		if ($s == 0)
		{
			push @indmanuf, $indmanuf;
			$s = 1;
			next;
		}
	}
	if ($s == 2)
	{
		$indproduct = $indproduct + 1;
		foreach(@product)
		{
			if(index($s1, $_) > -1)
			{
				$s = 0;
			}
		}
		if ($s == 0)
		{
			push @indproduct, $indproduct;
			$s = 2;
			next;
		}
	}
	if ($s == 3)
	{
		$indname = $indname + 1;
		foreach(@name)
		{
			if(index($s1, $_) > -1)
			{
				$s = 0;
			}
		}
		if ($s == 0)
		{
			push @indname, $indname;
			$s = 3;
			next;
		}
	}
}
close IN;

foreach(@indmanuf)
{
	$indmanuf = $_;
	foreach(@indproduct)
	{
		if ($indmanuf == $_)
		{
			$indproduct = $_;
			foreach(@indname)
			{
				if ($indmanuf == $_)
				{
					push @inds, $indmanuf;
				}
			}
		}
	}
}

open IN, "< $ARGV[1]" or die "Can't open $ARGV[1]: $!";
while (<IN>)
{
	if (m/ifdVendorID/)
	{
		$indmanuf = 0;
		$s = 1;
	}
	if (m/ifdProductID/)
	{
		$indproduct = 0;
		$s = 2;
	}
	if (m/ifdFriendlyName/)
	{
		$indname = 0;
		$s = 3;
	}
	if ($s == 1)
	{
		$indmanuf = $indmanuf + 1;
		foreach(@inds)
		{
			if($indmanuf == $_)
			{
				$s = 0;
			}
		}
		if ($s == 0)
		{
			$s = 1;
			next;
		}
	}
	if ($s == 2)
	{
		$indproduct = $indproduct + 1;
		foreach(@inds)
		{
			if($indproduct == $_)
			{
				$s = 0;
			}
		}
		if ($s == 0)
		{
			$s = 2;
			next;
		}
	}
	if ($s == 3)
	{
		$indname = $indname + 1;
		foreach(@inds)
		{
			if($indname == $_)
			{
				$s = 0;
			}
		}
		if ($s == 0)
		{
			$s = 3;
			next;
		}
	}
	print;
}

close IN;

